import java.awt.*;
import java.awt.event.*;

public class Rahmen extends Frame {
  // Rahmen zur Darstellung der Grafik

  private void erstelleRahmen (String text, int s) {
    setTitle(text);
    setSize(s, s);
    setLocation(50, 50);
    setBackground(new Color(250, 230, 230));
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e)
      {System.exit(0);}});
    } // Ende erstelleRahmen

  public Rahmen (String text, int seite) {
    erstelleRahmen(text, seite);
    add("Center", new Zeichnung());
    show();
    } // Ende Konstruktor

  } // Ende Rahmen

class Zeichnung extends Canvas {
  // zeichnet Kirchenfenster (Vierpass)

  private int xMax, yMax;

  private void Skalierung() {
    xMax = getSize().width - 1;
    yMax = getSize().height - 1;
    } // Ende Skalierung
    
  private void zeichneBogen (Graphics g, int x, int y, 
                                         int r, int w) {
    g.drawRect(x, y, r, r);
    // g.drawArc(x, y, r, r, w, 270);
    } // Ende zeichne Bogen

  private void zeichneVierpass (Graphics gisela) {
    int x = 50, y = 50;
    int R = xMax - 100;
    gisela.drawRect(x, y, R, R);
    int s0 = (int) Math.round(R * (2 - Math.sqrt(2.0)));
    int r0 = R - s0;
    zeichneBogen(gisela, x,          y + s0/2,   r0,  45);
    zeichneBogen(gisela, x + s0/2,   y,          r0, -45);
    zeichneBogen(gisela, x + s0/2,   y + R - r0, r0, 135);
    zeichneBogen(gisela, x + R - r0, y + s0/2,   r0, 225);
    } // Ende zeichneVierpass

  public void paint (Graphics g) {
    Skalierung();
    zeichneVierpass(g);
    } // Ende paint

  } // Ende Zeichnung
