import java.awt.*;
import java.awt.event.*;

public class Rahmen extends Frame {
  // Rahmen zur Darstellung der Grafik

  private void erstelleRahmen (String text) {
    setTitle(text);
    setSize(300, 300);
    setLocation(50, 50);
    setBackground(new Color(230, 250, 230));
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e)
      {System.exit(0);}});
    } // Ende erstelleRahmen

  public Rahmen (String text, int r, int s) {
    erstelleRahmen(text);
    add("Center", new Zeichnung(r, s));
    show();
    } // Ende Konstruktor

  } // Ende Rahmen

class Zeichnung extends Canvas {
  // zeichnet rechteckige Kreisfamilie

  private int radius, schritt;

  public Zeichnung (int r, int s)
    {radius = r; schritt = s;}

  private void zeichneKreis (Graphics g, int x, int y, int r) {
    g.fillRect(x - 1, y - 1, 2, 2);
    g.drawOval(x - r, y - r, 2 * r, 2 * r);
    } // Ende zeichneKreis

  public void paint (Graphics g) {
    int m = 6, n = 10;
    for (int x = 2 * radius; x < 200; x = x + schritt)
      for (int y = 2 * radius; y < 160; y = y + schritt)
        zeichneKreis(g, x, y, radius);
    } // Ende paint

  } // Ende Zeichnung
