import java.awt.*;
import java.awt.event.*;

public class Rahmen extends Frame {
  // Rahmen zur Darstellung der Grafik

  private void erstelleRahmen (String text) {
    setTitle(text);
    setSize(800, 200);
    setLocation(100, 100);
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e)
      {System.exit(0);}});
    } // Ende erstelleRahmen

  public Rahmen (int x0, int x1, int y0, int y1) {
    erstelleRahmen("Funktionsgraph");
    add("Center", new Zeichnung(x0, x1, y0, y1));
    show();
    } // Ende Konstruktor

  } // Ende Rahmen

class Zeichnung extends Canvas {

  int   xMin, xMax, yMin, yMax;
  int   xsMin, xsMax, ysMin, ysMax;
  float xMF, yMF;

  public Zeichnung (int x0, int x1, int y0, int y1)
    {xMin = x0; xMax = x1; yMin = y0; yMax = y1;}

  double f1 (double x)
    {return Math.sin(x) + Math.sin(3 * x)/3.0
                        + Math.sin(5 * x)/5.0;}
  
  double f2 (double x)
    {return (((x - 4) * x - 2) * x + 4) * x + 25;}

  private void Skalierung() {
    Dimension d = getSize();
    xsMax = d.width - 1;
    ysMax = d.height - 1;
    xMF = (float) xsMax / (xMax - xMin);
    yMF = (float) ysMax / (yMax - yMin);
    } // Ende Skalierung

  private void zeichneAchsen (Graphics g) {
    int xs0 = Math.round(-xMin * xMF);
    int ys0 = Math.round( yMax * yMF);
    g.drawLine(1, ys0, xsMax, ys0);
    g.drawLine(xs0, 1, xs0, ysMax);
    } // zeichne Achsen
  
  public void paint (Graphics g) {
    Skalierung();
    zeichneAchsen(g);
    for (int xs = 1; xs < xsMax; xs++) {
      double x = (double) xMin + xs / xMF;
      double y = f1(x);
      int ys = (int) Math.round((yMax - y) * yMF);
      // g.setColor(Color.blue);
      g.fillRect(xs, ys, 2, 2);
      } // Ende for
    } // Ende paint

  } // Ende Zeichnung

