import java.awt.*;
import java.awt.event.*;

public class Muster extends Frame {
  // Rahmen zur Grafikdarstellung

  public static void main (String[] xy)
    {new Muster();}
  
  public Muster() {
    setTitle("Funktionsmuster");
    setSize(200, 200);
    setLocation(50, 50);
    setVisible(true);
    add("Center", new Zeichnung());
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e)
      {System.exit(0);}});
    show();
    } // Ende Konstruktor

  } // Ende Muster

class Zeichnung extends Canvas {
  // zeichnet Funktionsmuster

  int   xMin, xMax, yMin, yMax;
  int   xsMin, xsMax, ysMin, ysMax;
  float xMF, yMF;

  float f1 (float x, float y)
    {return x * y * (x * x - y * y) / (x * x + y * y);}

  float f2 (float x, float y)
    {return (x - (float) Math.cos(y * y)) *
            (y - (float) Math.sin(x * x));}

  float f3 (float x, float y)
    {return (float) (Math.sin(x) * Math.sin(x) + y * y);}

  float f4 (float x, float y)
    {return (float) ((x + Math.cos(y)) * (y - Math.sin(x)));}

  float f5 (float x, float y)
    {return (float) (Math.cos(x * x) + x * x * y * y);}

  float f6 (float x, float y)
    {return (float) (x * y * (x * x - y * y)/(x * x + y * y));}

  float f7 (float x, float y)
    {return (float) (x * x + y * y - (int)(x * x + y * y));}

  float f8 (float x, float y)
    {return (float) (x * y);}

  float f9 (float x, float y)
    {return (float) (f3(x, y) - (int) f5(x, y));}

  float f10 (float x, float y)
    {return (float) (f9(x, y) * f9(x, y));}

  float f11 (float x, float y)
    {return (float) (x * Math.sin(x * x) + y * Math.sin(y * y));}

  float f12 (float x, float y)
    {return (float) (f3(x, y) * f3(x, y) - f5(x, y));}

  float f13 (float x, float y)
    {return (float) (f3(x, y) - f5(x, y));}

  private void Skalierung() {
    xMin = -5; xMax = 5;
    yMin = -5; yMax = 5;

    xsMax = getSize().width - 1;
    ysMax = getSize().height - 1;

    xMF = (float) xsMax / (xMax - xMin);
    yMF = (float) ysMax / (yMax - yMin);
    } // Ende Skalierung
  
  public void paint (Graphics g) {
    Skalierung();
    Color[] farben = {Color.black, Color.white, Color.cyan,
                      Color.darkGray, Color.gray, Color.green,
                      Color.lightGray, Color.magenta, Color.orange,
                      Color.pink, Color.red, Color.blue}; 
    for (int xs = 1; xs < xsMax; xs++) 
      for (int ys = 1; ys < ysMax; ys++) {
        float x = (float) xMin + xs / xMF;
        float y = (float) yMax - ys / yMF;
        int wert = (int) Math.round(Math.abs(f13(x, y)));
        // System.out.print(wert + " ");
        g.setColor(farben[((int) wert) % 12]);
        g.fillRect(xs, ys, 1, 1); 
        } // Ende for
    } // Ende paint

  } // Ende Zeichnung
