unit uAutomat;

interface
uses Graphics, ExtCtrls, Controls, SysUtils;

type
  tPartner = class
    public
    zustand, neuerZustand, punkte  : integer;
    left,top,xpos,ypos,width,height: integer;
    bild                           : tCanvas;
    wasDerNachbarTat               : array[1..8] of boolean;
    name                           : string;
    constructor create(canvas: tCanvas; x,y: integer);
    procedure init;
    procedure zeigeDich;
    procedure handelMitDenNachbarn;
    procedure wechseleZustand;
    function handelsergebnisMit(p: tPartner; lage: integer): integer;
    function kooperiertMit( lage: integer): boolean;
    end;

implementation
uses uWelt;

constructor tPartner.create(canvas: tCanvas; x,y: integer);
begin
bild   := canvas;
left   := 11*x;
top    := 11*y+40;
width  := 10;
height := 10;
name := 'Px'+IntToStr(x)+'y'+IntToStr(y);
xpos := x;
ypos := y;
end;

procedure tPartner.init;
var i: integer;
begin
zustand := random(3)+1;
neuerZustand := zustand;
for i := 1 to 8 do wasDerNachbarTat[i] := true;
punkte := 0;
zeigeDich
end;

procedure tPartner.zeigeDich;
begin
with bild do begin
  pen.color := clBlack;
  case zustand of
    1: brush.color := clGreen;  //der Naive: kooperiert immer
    2: brush.color := clRed;    //der Betrger: kooperiert nie
    3: brush.color := clYellow; //TitForTat
    end;
  brush.style := bsSolid;
  rectangle(left,top,left+width,top+height);
  end;
end;

procedure tPartner.handelMitDenNachbarn;
var xlinks,xrechts,yoben,yunten: integer;
begin
if xpos = 0 then xlinks  := uwelt.xmax else xlinks := xpos-1;  //eine "Zylinderwelt" in beiden Richtungen
if xpos = uwelt.xmax then xrechts  := 0 else xrechts := xpos+1;
if ypos = 0 then yoben  := uwelt.ymax else yoben := ypos-1;
if ypos = uwelt.ymax then yunten  := 0 else yunten := ypos+1;

punkte := handelsergebnisMit(welt.elemente[xlinks,ypos],1);
punkte := punkte + handelsergebnisMit(welt.elemente[xlinks,yoben],2);
punkte := punkte + handelsergebnisMit(welt.elemente[xpos,yoben],3);
punkte := punkte + handelsergebnisMit(welt.elemente[xrechts,yoben],4);
punkte := punkte + handelsergebnisMit(welt.elemente[xrechts,ypos],5);
punkte := punkte + handelsergebnisMit(welt.elemente[xrechts,yunten],6);
punkte := punkte + handelsergebnisMit(welt.elemente[xpos,yunten],7);
punkte := punkte + handelsergebnisMit(welt.elemente[xlinks,yunten],8);
end;

procedure tPartner.wechseleZustand;
var xlinks,xrechts,yoben,yunten,bestPunkte,bestZustand: integer;
begin
if xpos = 0 then xlinks  := uwelt.xmax else xlinks := xpos-1;  //eine "Zylinderwelt" in beiden Richtungen
if xpos = uwelt.xmax then xrechts  := 0 else xrechts := xpos+1;
if ypos = 0 then yoben  := uwelt.ymax else yoben := ypos-1;
if ypos = uwelt.ymax then yunten  := 0 else yunten := ypos+1;

bestPunkte := punkte;
bestZustand := zustand;
if bestPunkte < welt.elemente[xlinks,ypos].punkte then begin
  bestpunkte := welt.elemente[xlinks,ypos].punkte;
  bestZustand := welt.elemente[xlinks,ypos].zustand;
  end;
if bestPunkte < welt.elemente[xlinks,yoben].punkte then begin
  bestpunkte := welt.elemente[xlinks,yoben].punkte;
  bestZustand := welt.elemente[xlinks,yoben].zustand;
  end;
if bestPunkte < welt.elemente[xpos,yoben].punkte then begin
  bestpunkte := welt.elemente[xpos,yoben].punkte;
  bestZustand := welt.elemente[xpos,yoben].zustand;
  end;
if bestPunkte < welt.elemente[xrechts,yoben].punkte then begin
  bestpunkte := welt.elemente[xrechts,yoben].punkte;
  bestZustand := welt.elemente[xrechts,yoben].zustand;
  end;
if bestPunkte < welt.elemente[xrechts,ypos].punkte then begin
  bestpunkte := welt.elemente[xrechts,ypos].punkte;
  bestZustand := welt.elemente[xrechts,ypos].zustand;
  end;
if bestPunkte < welt.elemente[xrechts,yunten].punkte then begin
  bestpunkte := welt.elemente[xrechts,yunten].punkte;
  bestZustand := welt.elemente[xrechts,yunten].zustand;
  end;
if bestPunkte < welt.elemente[xpos,yunten].punkte then begin
  bestpunkte := welt.elemente[xpos,yunten].punkte;
  bestZustand := welt.elemente[xpos,yunten].zustand;
  end;
if bestPunkte < welt.elemente[xlinks,yunten].punkte then begin
  bestpunkte := welt.elemente[xlinks,yunten].punkte;
  bestZustand := welt.elemente[xlinks,yunten].zustand;
  end;
neuerZustand := bestZustand;
end;

function tPartner.handelsergebnisMit(p: tPartner; lage: integer): integer;
var inverseLage        : integer;
    derAndereKooperiert: boolean;
    ichKooperiere      : boolean;
begin
case lage of
  1..4: inverseLage := 4+lage;
  5..8: inverseLage := lage-4;
  end;
derAndereKooperiert := p.kooperiertMit(inverseLage); //nachsehen, was der Partner tut
wasDerNachbarTat[lage] := derAndereKooperiert;
ichKooperiere := kooperiertMit(lage);
if ichKooperiere                      //jetzt reagieren
  then if derAndereKooperiert
    then result := random(9)+2
    else result := 0
else
  if derAndereKooperiert
    then result := random(20)
    else result := random(2);
end;

function tPartner.kooperiertMit( lage: integer): boolean;
begin
case zustand of
  1: result := true;                   //der Naive: kooperiert immer
  2: result := false;                  //der Betrger: kooperiert nie
  3: result := wasDerNachbarTat[lage]; //TitForTat
  end
end;

end.
