unit uDiagramm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TDiagramm = class(TForm)
    Anzeige: TImage;
    Panel1: TPanel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Init;
    procedure zeichne;
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Diagramm: TDiagramm;

implementation
uses uWelt;
{$R *.dfm}

var x,y1,y2,y3,y1alt,y2alt,y3alt: integer;
    x1,x2,x3      : integer;
    hoehe,breite,bsp,bsp_alt: integer;
    ersterPunkt : boolean;
    xpos: single;
    schrittweite: single = 1.0;

procedure TDiagramm.FormCreate(Sender: TObject);
begin
init;
show;
with Image1.canvas do
  begin
  pen.color := clBlack;
  textout(5,2,'naiv: ');
  pen.color := clGreen;
  moveto(30,10); Lineto(60,10);
  pen.color := clBlack;
  brush.color := clGreen;
  rectangle(42,7,48,13);
  brush.color := clWhite;
  textout(72,2,'bse: ');
  pen.color := clRed;
  moveto(100,10); Lineto(130,10);
  pen.color := clBlack;
  brush.color := clRed;
  rectangle(112,7,118,13);
  brush.color := clwhite;
  textout(142,2,'gewitzt: ');
  pen.color := clOrange;
  moveto(180,10); Lineto(210,10);
  pen.color := clBlack;
  brush.color := clOrange;
  rectangle(192,7,198,13);
  brush.color := clwhite;
  textout(220,2,'Gesamtgewinn: ');
  pen.color := clBlack;
  pen.Width := 3;
  moveto(295,10); Lineto(325,10);
  end;
end;

procedure tDiagramm.init;
begin
with anzeige.Canvas do
  begin
  hoehe := anzeige.Height;
  breite := anzeige.width;
  pen.Color := clBlack;
  brush.Color := clWhite;
  brush.style := bsSolid;
  rectangle(0,0,breite,hoehe);
  moveTo(10,hoehe-10); LineTo(10,10);LineTo(8,15);LineTo(12,15); LineTo(10,10);
  moveTo(10,hoehe-10);LineTo(breite-20,hoehe-10); LineTo(Breite-25,hoehe-12);
  LineTo(Breite-25,hoehe-8);LineTo(breite-20,hoehe-10);
  xpos := 12;
  ersterPunkt := true;
  end
end;

procedure tDiagramm.zeichne;
var i,j,x,y1,y2,y3: integer;
    faktor        : double;
begin
y1 := 0; y2 := 0; y3 := 0;
x := round(xpos);
bsp := 0;
faktor := (hoehe-25)/((uwelt.xmax+1)*(uwelt.ymax+1));
for i := 0 to uwelt.xmax do
  for j := 0 to uwelt.ymax do
    begin
    bsp := bsp + welt.elemente[i,j].punkte;
    case welt.elemente[i,j].zustand of
      1: y1 := y1 + 1;
      2: y2 := y2 + 1;
      3: y3 := y3 + 1
      end;
    end;
y1 := hoehe-10-round(y1*faktor);
y2 := hoehe-10-round(y2*faktor);
y3 := hoehe-10-round(y3*faktor);
bsp := hoehe-10-round(bsp*faktor/50);
with anzeige.Canvas do
  if ersterPunkt then
    begin
    y1alt := y1;
    y2alt := y2;
    y3alt := y3;
    bsp_alt := bsp;
    ersterPunkt := false
    end
  else
    begin
    pen.Width := 1;
    pen.color := clGreen;
    moveto(x,y1alt);
    lineto(x+1,y1);
    y1alt := y1;
    if (x mod 30 = 0) and (x<>x1) then
      begin
      pen.color := clBlack;
      brush.color := clGreen;
      rectangle(x-3,y1-3,x+3,y1+3);
      x1 := x;
      end;
    pen.color := clRed;
    moveto(x,y2alt);
    lineto(x+1,y2);
    y2alt := y2;
    if ((x+10) mod 30 = 0) and (x<>x2) then
      begin
      pen.color := clBlack;
      brush.color := clRed;
      rectangle(x-3,y2-3,x+3,y2+3);
      x2 := x;
      end;
    pen.color := clOrange;
    moveto(x,y3alt);
    lineto(x+1,y3);
    y3alt := y3;
    if ((x+20) mod 30 = 0) and (x<>x3) then
      begin
      pen.color := clBlack;
      brush.color := clOrange;
      rectangle(x-3,y3-3,x+3,y3+3);
      x3 := x;
      end;
    pen.color := clBlack;
    pen.Width := 3;
    moveto(x,bsp_alt);
    lineto(x+1,bsp);
    bsp_alt := bsp;
    xpos := xpos + schrittweite;
    if xpos > breite-30 then init;
    end;
end;

procedure TDiagramm.ComboBox1Change(Sender: TObject);
begin
case ComboBox1.ItemIndex of
  0: schrittweite := 0.1;
  1: schrittweite := 0.2;
  2: schrittweite := 0.5;
  3: schrittweite := 1;
  4: schrittweite := 2;
  5: schrittweite := 5;
  end
end;

end.
